--
-- whAutomation
--
-- fcelsa
--
-- script for some automation of woodHarvester
--
-- 2017-02
--
-- H = four state: AUTO --> FULL AUTO --> ON --> OFF
-- Y = when ON select from the three pre-set length
--     when FULL AUTO or AUTO automatic selection of length from pre-set depending from size of logs
--     when OFF game default behavior with 1 m. step
--
-- Default activation when woodharvested turned on, hud also on
--
-- 1.0 prima versione funzionante solo testo
-- 1.1 projected hud su alberi grabbati e da tagliare
-- 1.2 aggiunto fade affect text di TyKonKet
-- 1.3 serie di bugfix ed aggiunta di hud specifico con classe di TyKonKet
-- 1.4 aggiunto effetti sonori, sistemazione hud e bugfix vari
-- 1.5 aggiunto helpline
-- 1.6 spostato selezione automatica delle misure in updateTick e controllo not self.isAttachedSplitShapeMoving
-- 1.7 revisione codice per MP, correzione bug scritte alberi, correzione hud, aggiunta rotazione hud in full-auto.

whAutomation = {};
whAutomation.Version = 1.76;

whAutomation.dir = g_currentModDirectory;

whAutomation.STATE_NAUTO = 0;
whAutomation.STATE_FAUTO = 1;
whAutomation.STATE_ON = 2;
whAutomation.STATE_OFF = 3;
whAutomation.STATE_LEAVE = 4;
whAutomation.g_i18n = {};
whAutomation.g_i18n["shop_messagePurchaseReady"] = g_i18n:getText("shop_messagePurchaseReady");
whAutomation.g_i18n["shop_messageLeasingReady"] = g_i18n:getText("shop_messageLeasingReady");

function whAutomation.onVehicleBoughtCallback()
    g_i18n.globalI18N:setText("shop_messagePurchaseReady", whAutomation.g_i18n["shop_messagePurchaseReady"]);
    g_i18n.globalI18N:setText("shop_messageLeasingReady", whAutomation.g_i18n["shop_messageLeasingReady"]);
end
g_shopScreen.onVehicleBoughtCallback = Utils.appendedFunction(g_shopScreen.onVehicleBoughtCallback, whAutomation.onVehicleBoughtCallback);

function whAutomation.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(WoodHarvester, specializations);
end

function whAutomation:preLoad(savegame)
    if self.isClient then
        local filename = Utils.getFilename("pdabeep.wav", whAutomation.dir);
        self.whaSoundSample = createSample("pdabeep");
        loadSample(self.whaSoundSample, filename, false);
        local filename = Utils.getFilename("scanbeep.wav", whAutomation.dir);
        self.whaScanSample = createSample("scanbeep");
        loadSample(self.whaScanSample, filename, false);
    end
    
    self.hud = {};
    local w = 140;
    local h = 38;
    local imageSize = {128, 128};
    
    self.hud.bg = HudImage:new("HudBackground", g_baseUIFilename, 0.5, g_safeFrameOffsetY, w, h);
    self.hud.bg:setAlignment(Hud.ALIGNS_VERTICAL_BOTTOM, Hud.ALIGNS_HORIZONTAL_CENTER);
    self.hud.bg:setUVs(g_colorBgUVs);
    self.hud.bg:setColor(unpack(g_colorBg));
    
    self.hud.size1Bg = HudImage:new("Size1Bg", g_baseUIFilename, 0.0285, 0.1052, 30, 30, self.hud.bg);
    self.hud.size1Bg:setUVs(g_colorBgUVs);
    self.hud.size1Bg:setColor(0.0075, 0.0075, 0.0075, 1);
    self.hud.size1Bg:addCallback(self, whAutomation.size1MouseClick, Hud.CALLBACKS_MOUSE_CLICK);
    self.hud.size1Bg:addCallback(self, whAutomation.sizeMouseEnter, Hud.CALLBACKS_MOUSE_ENTER);
    self.hud.size1Bg:addCallback(self, whAutomation.sizeMouseLeave, Hud.CALLBACKS_MOUSE_LEAVE);
    self.hud.size1Icon = HudImage:new("Size1Icon", HudManager.modDir .. "sizeIcons.dds", 0.5, 0.9, 24, 15, self.hud.size1Bg);
    self.hud.size1Icon:setAlignment(Hud.ALIGNS_VERTICAL_TOP, Hud.ALIGNS_HORIZONTAL_CENTER);
    self.hud.size1Icon.normalUVs = GuiUtils.getUVs("2px 2px 34px 23px", imageSize);
    self.hud.size1Icon.activeUVs = GuiUtils.getUVs("38px 2px 34px 23px", imageSize);
    self.hud.size1Icon:setUVs(self.hud.size1Icon.normalUVs);
    self.hud.size1Text = HudText:new("Size1Text", "12 m", 9, 0.5, 0.1, true, self.hud.size1Bg);
    self.hud.size1Text:setAlignment(Hud.ALIGNS_VERTICAL_BOTTOM, Hud.ALIGNS_HORIZONTAL_CENTER);
    
    self.hud.size2Bg = HudImage:new("Size2Bg", g_baseUIFilename, 0.2714, 0.1052, 30, 30, self.hud.bg);
    self.hud.size2Bg:setUVs(g_colorBgUVs);
    self.hud.size2Bg:setColor(0.0075, 0.0075, 0.0075, 1);
    self.hud.size2Bg:addCallback(self, whAutomation.size2MouseClick, Hud.CALLBACKS_MOUSE_CLICK);
    self.hud.size2Bg:addCallback(self, whAutomation.sizeMouseEnter, Hud.CALLBACKS_MOUSE_ENTER);
    self.hud.size2Bg:addCallback(self, whAutomation.sizeMouseLeave, Hud.CALLBACKS_MOUSE_LEAVE);
    self.hud.size2Icon = HudImage:new("Size2Icon", HudManager.modDir .. "sizeIcons.dds", 0.5, 0.9, 24, 15, self.hud.size2Bg);
    self.hud.size2Icon:setAlignment(Hud.ALIGNS_VERTICAL_TOP, Hud.ALIGNS_HORIZONTAL_CENTER);
    self.hud.size2Icon.normalUVs = GuiUtils.getUVs("2px 27px 34px 23px", imageSize);
    self.hud.size2Icon.activeUVs = GuiUtils.getUVs("38px 27px 34px 23px", imageSize);
    self.hud.size2Icon:setUVs(self.hud.size2Icon.normalUVs);
    self.hud.size2Text = HudText:new("Size2Text", "6 m", 9, 0.5, 0.1, true, self.hud.size2Bg);
    self.hud.size2Text:setAlignment(Hud.ALIGNS_VERTICAL_BOTTOM, Hud.ALIGNS_HORIZONTAL_CENTER);
    
    self.hud.size3Bg = HudImage:new("Size3Bg", g_baseUIFilename, 0.5142, 0.1052, 30, 30, self.hud.bg);
    self.hud.size3Bg:setUVs(g_colorBgUVs);
    self.hud.size3Bg:setColor(0.0075, 0.0075, 0.0075, 1);
    self.hud.size3Bg:addCallback(self, whAutomation.size3MouseClick, Hud.CALLBACKS_MOUSE_CLICK);
    self.hud.size3Bg:addCallback(self, whAutomation.sizeMouseEnter, Hud.CALLBACKS_MOUSE_ENTER);
    self.hud.size3Bg:addCallback(self, whAutomation.sizeMouseLeave, Hud.CALLBACKS_MOUSE_LEAVE);
    self.hud.size3Icon = HudImage:new("Size3Icon", HudManager.modDir .. "sizeIcons.dds", 0.5, 0.9, 24, 15, self.hud.size3Bg);
    self.hud.size3Icon:setAlignment(Hud.ALIGNS_VERTICAL_TOP, Hud.ALIGNS_HORIZONTAL_CENTER);
    self.hud.size3Icon.normalUVs = GuiUtils.getUVs("2px 52px 34px 23px", imageSize);
    self.hud.size3Icon.activeUVs = GuiUtils.getUVs("38px 52px 34px 23px", imageSize);
    self.hud.size3Icon:setUVs(self.hud.size3Icon.normalUVs);
    self.hud.size3Text = HudText:new("Size3Text", "5 m", 9, 0.5, 0.1, true, self.hud.size3Bg);
    self.hud.size3Text:setAlignment(Hud.ALIGNS_VERTICAL_BOTTOM, Hud.ALIGNS_HORIZONTAL_CENTER);
    
    self.hud.stateBg = HudImage:new("State3Bg", g_baseUIFilename, 0.7571, 0.1052, 30, 30, self.hud.bg);
    self.hud.stateBg:setUVs(g_colorBgUVs);
    self.hud.stateBg:setColor(0.0075, 0.0075, 0.0075, 1);
    self.hud.stateBg:addCallback(self, whAutomation.changeModeMouseClick, Hud.CALLBACKS_MOUSE_CLICK);
    --self.hud.stateText = HudText:new("StateText", " X", 9, 0.5, 0.5, true, self.hud.stateBg);
    --self.hud.stateText:setAlignment(Hud.ALIGNS_VERTICAL_CENTER, Hud.ALIGNS_HORIZONTAL_CENTER);
    --self.hud.stateText:setColor(0.2122, 0.5271, 0.0307, 1);
    self.hud.stateIcon = HudImage:new("StateIcon", HudManager.modDir .. "sizeIcons.dds", 0.5, 0.1, 24, 24, self.hud.stateBg);
    self.hud.stateIcon:setAlignment(Hud.ALIGNS_VERTICAL_BOTTOM, Hud.ALIGNS_HORIZONTAL_CENTER);
    self.hud.stateIcon.fnautoUVs = GuiUtils.getUVs("74px 2px 34px 34px", imageSize);
    self.hud.stateIcon.setLenUVs = GuiUtils.getUVs("74px 38px 34px 34px", imageSize);
    self.hud.stateIcon.manualUVs = GuiUtils.getUVs("74px 74px 34px 34px", imageSize);
    self.hud.stateIcon:setUVs(self.hud.stateIcon.fnautoUVs);
    self.hud.stateIcon.rotationDeg = 0;
    self.hud.bg:setIsVisible(false, true);
    if self.isServer then
        if savegame == nil then
            self.tempHelpInfoText = g_i18n:getText("WHA_TEMP_INFO");
        end
    end
end

function whAutomation:load(savegame)
    self.releaseTree = SpecializationUtil.callSpecializationsFunction("releaseTree");
    self.toggleStatus = whAutomation.toggleStatus;
    self.toggleLengthSet = whAutomation.toggleLengthSet;
    self.setIsTurnedOn = whAutomation.setIsTurnedOn;
    self.changeLength = whAutomation.changeLength;
end

function whAutomation:postLoad(savegame)
    if self.isClient then 
        self.whInit = true;
        self.whStatus = whAutomation.STATE_NAUTO;

        if self.cutLengthMin then
            self.defaultcutLengthMin = self.cutLengthMin;
        end
        if self.cutLengthMax then
            self.defaultcutLengthMax = self.cutLengthMax;
        end
        if self.cutLengthStep then
            self.defaultcutLengthStep = self.cutLengthStep;
        end
    end
    
    self.whPresetChanged = 1;
    self.updateHud = false;
    self.defaultPreset = {11, 6, 2};
    self.maxTreeSize = 0;
    self.cutLengthStep = 0.1;
    self.shapeInfoText = "";
    
    -- 0.087
    self.whAutomationFadeEffect = FadeEffect:new({position = {x = 0.5, y = 1 - g_safeFrameOffsetY},
        align = {x = FadeEffect.ALIGNS.CENTER, y = FadeEffect.ALIGNS.TOP},
        size = 0.024, shadow = true,
        shadowPosition = {x = 0.0025, y = 0.0035},
        statesTime = {0.75, 2, 0.95}});
    
    if self.isServer then 
        if savegame ~= nil and not savegame.resetVehicles then
            local a, b, c = Utils.getVectorFromString(getXMLString(savegame.xmlFile, savegame.key .. "#whdefaultPreset"));
            if a ~= nil and a ~= 0 then
                self.defaultPreset = {a, b, c};
            else
                self.defaultPreset = {11, 6, 2};
            end
        elseif savegame == nil then
            g_i18n.globalI18N:setText("shop_messagePurchaseReady", g_i18n:getText("shop_overwrite_messagePurchaseReady"));
            g_i18n.globalI18N:setText("shop_messageLeasingReady", g_i18n:getText("shop_overwrite_messageLeasingReady"));
        end
    end

    -- permette di abbattere tutti i tipi di alberi con un wood harvester, indiscriminatamente.
    for i = 1, #SplitUtil.splitTypes do
        --print("whAutomation debug: "..SplitUtil.splitTypes[i].name.."  "..SplitUtil.splitTypes[i].pricePerLiter);
        SplitUtil.splitTypes[i].allowsWoodHarvester = true;
    end
    
    -- per poter abbattere gli alberi più grandi devo anche cambiare il maxRadius ammesso, lo raddoppio...
    -- e memorizzo comunque il valore originale, perché poi mi serve... ma a che mi serve non me lo ricordo...
    self.originalMaxradius = self.cutMaxRadius;
    self.cutMaxRadius = self.cutMaxRadius * 2;

    self.cutCounter = 0;
    
    self.callDelayedCut = DelayedCallBack:new(function(foo)whAutomation.delayedAutoCut(foo); end, self);
    
    self.hud.size1Text:setText(string.format("%.1f m", self.defaultPreset[1]));
    self.hud.size2Text:setText(string.format("%.1f m", self.defaultPreset[2]));
    self.hud.size3Text:setText(string.format("%.1f m", self.defaultPreset[3]));
    self.whPresetChanged = 1;
    self.currentCutLength = self.defaultPreset[self.whPresetChanged];

end

function whAutomation:getSaveAttributesAndNodes(nodeIdent)
    local attributes = 'whdefaultPreset="' .. self.defaultPreset[1] .. ' ' .. self.defaultPreset[2] .. ' ' .. self.defaultPreset[3] .. '"';
    local nodes = "";
    return attributes, nodes;
end

function whAutomation:delete()
    if self.whaSoundSample then
        delete(self.whaSoundSample);
    end
    if self.whaScanSample then
        delete(self.whaScanSample);
    end
    self.hud.bg:delete(true);
end

function whAutomation:onEnter()
    if self.whInit and self.whStatus ~= whAutomation.STATE_OFF and self:getIsTurnedOn() and self.isEntered then
        self.hud.bg:setIsVisible(true, true);
    end
end

function whAutomation:onLeave()
    self:toggleStatus(whAutomation.STATE_LEAVE);
end

function whAutomation:mouseEvent(posX, posY, isDown, isUp, button)
end

function whAutomation:keyEvent(unicode, sym, modifier, isDown)
    if self:getIsActiveForInput(true) and self:getIsTurnedOn() then
        if Input.isKeyPressed(Input.KEY_KP_7) then
            self:toggleLengthSet(1);
        end
        if Input.isKeyPressed(Input.KEY_KP_8) then
            self:toggleLengthSet(2);
        end
        if Input.isKeyPressed(Input.KEY_KP_9) then
            self:toggleLengthSet(3);
        end
        
        if Input.isKeyPressed(Input.KEY_KP_minus) then
            self:changeLength(self.whPresetChanged, -1);
            self.hud.size1Text:setText(string.format("%.1f m", self.defaultPreset[1]));
            self.hud.size2Text:setText(string.format("%.1f m", self.defaultPreset[2]));
            self.hud.size3Text:setText(string.format("%.1f m", self.defaultPreset[3]));
            self.currentCutLength = self.defaultPreset[self.whPresetChanged];
        end
        if Input.isKeyPressed(Input.KEY_KP_plus) then
            self:changeLength(self.whPresetChanged, 1);
            self.hud.size1Text:setText(string.format("%.1f m", self.defaultPreset[1]));
            self.hud.size2Text:setText(string.format("%.1f m", self.defaultPreset[2]));
            self.hud.size3Text:setText(string.format("%.1f m", self.defaultPreset[3]));
            self.currentCutLength = self.defaultPreset[self.whPresetChanged];
        end
    end
end

function whAutomation:update(dt)
    if g_currentMission.paused then
        return;
    end
    
    if self:getIsActive() then
        self.hud.stateIcon.rotationDeg = self.hud.stateIcon.rotationDeg - dt * 0.12;
        if self.hud.stateIcon.rotationDeg < 0 then
            self.hud.stateIcon.rotationDeg = self.hud.stateIcon.rotationDeg + 360;
        end
        
        -- verficare se eseguire solo in determinate condizioni
        self.whAutomationFadeEffect:update(dt);
        self.callDelayedCut:update(dt);

        if self.whStatus == whAutomation.STATE_OFF then 
            g_currentMission:addHelpButtonText(g_i18n:getText("WHA_SETWHON"), InputBinding.TOGGLE_AI);
        end
        
        if self.updateHud then
            if self.treeCutLengthHud ~= nil then
                VehicleHudUtils.setHudValue(self, self.treeCutLengthHud, self.currentCutLength * 100, 9999);
            end
            self.updateHud = false;
        end
        
        if self:getIsActiveForInput(true) and self:getIsTurnedOn() then
            if InputBinding.isPressed(InputBinding.WHA_MOUSEONOFF) and self.whInit then
                InputBinding.setShowMouseCursor(true);
                HudManager.lockVehicleCameras(self);
            else
                InputBinding.setShowMouseCursor(false);
                HudManager.unlockVehicleCameras(self);
            end
            
            if InputBinding.hasEvent(InputBinding.TOGGLE_AI) then
                self:toggleStatus();
            end
            
            if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA3) then
                if not self.isAttachedSplitShapeMoving and self.whInit then
                    self:toggleLengthSet();
                end
            end
            
            if InputBinding.hasEvent(InputBinding.WHA_UNGRAB) then
                self:releaseTree();
            end
            
            local rotation = math.rad(self.hud.stateIcon.rotationDeg);
            local w, h = self.hud.stateIcon:getRenderDimension();
            if self.whStatus == whAutomation.STATE_FAUTO and not self.hud.stateIcon.setLenUVs.visible then
                self.hud.stateIcon:setRotation(rotation, w * 0.5, h * 0.5, true)
            else
                self.hud.stateIcon:setRotation(0, w * 0.5, h * 0.5, true)
            end
        
        end
        
        -- eventuale parte per staccare le punte... sistemare i valori...
        if self.attachedSplitShape ~= nil and self.maxTreeSize ~= 0 and self.cutCounter > 1 then
            if self.maxTreeSize < 2 and self.lastDiameter < 0.18 then
                self:releaseTree();
                self.updateHud = true;
            end
        end
    
    end
end

function whAutomation:updateTick(dt)
    
    if self:getIsActive() then
        if self.whStatus == whAutomation.STATE_NAUTO or self.whStatus == whAutomation.STATE_FAUTO then
            if self.attachedSplitShape ~= nil and self.maxTreeSize ~= 0 and not self.isAttachedSplitShapeMoving then
                if self.maxTreeSize >= 14 and self.lastDiameter > 0.44 then
                    if self.whPresetChanged ~= 1 then
                        self:toggleLengthSet(1);
                    end
                elseif self.maxTreeSize >= self.defaultPreset[2] and self.lastDiameter > 0.34 then
                    if self.whPresetChanged ~= 2 then
                        self:toggleLengthSet(2);
                    end
                elseif self.maxTreeSize >= self.defaultPreset[1] and self.lastDiameter < 0.30 then
                    if self.whPresetChanged ~= 3 then
                        self:toggleLengthSet(3);
                    end
                else
                    if self.whPresetChanged ~= 3 then
                        self:toggleLengthSet(3);
                    end
                end
            end
        end
        
        -- prepara il testo per l'albero di fronte alla testa di taglio prima del taglio.
        if self.curSplitShape ~= nil and self.attachedSplitShape == nil then
            self.shapeInfoText = "";
            local sizeX, sizeY, sizeZ, numConvexes, numAttachments = getSplitShapeStats(self.curSplitShape);
            local splitType = SplitUtil.splitTypes[getSplitType(self.curSplitShape)];
            if sizeX ~= nil then
                local maxSize = math.max(sizeX, math.max(sizeY, sizeZ));
                if maxSize ~= 0 then 
                    self.shapeInfoText = self.shapeInfoText .. splitType.name .. "\n";
                    self.shapeInfoText = self.shapeInfoText .. string.format(" m. %02.1f", maxSize);
                    self.shapeInfoText = self.shapeInfoText .. string.format("  D. %03d", self.lastDiameter * 1000);
                end;
            end
        else
            self.shapeInfoText = "";
        end
    end

end

function whAutomation:draw()
    
    if self:getIsActiveForInput(true) and self:getIsTurnedOn() then

        if self.tempHelpInfoText then
            g_currentMission:addExtraPrintText(self.tempHelpInfoText);
        end
        
        self.whAutomationFadeEffect:draw();
        
        if self.attachedSplitShape ~= nil then
            local sizeX, sizeY, sizeZ, numConvexes, numAttachments = getSplitShapeStats(self.attachedSplitShape);
            local splitType = SplitUtil.splitTypes[getSplitType(self.attachedSplitShape)];
            if sizeX ~= nil then
                self.maxTreeSize = math.max(sizeX, math.max(sizeY, sizeZ));
                -- alberi oltre il tipo 4 vengono solo tagliati  -  1=abete, 2=pino, 3=larice, 4=betulla ok tagliati e defogliati
                if splitType.splitType > 4 then
                    self:releaseTree();
                end
            end
        else
            self.maxTreeSize = 0;
        end
        
        if self.whPresetChanged == 1 then
            self.hud.size1Text:setColor(0.2122, 0.5271, 0.0307, 1);
            self.hud.size1Icon:setUVs(self.hud.size1Icon.activeUVs);
        else
            self.hud.size1Text:setColor(1, 1, 1, 1);
            self.hud.size1Icon:setUVs(self.hud.size1Icon.normalUVs);
        end
        
        if self.whPresetChanged == 2 then
            self.hud.size2Text:setColor(0.2122, 0.5271, 0.0307, 1);
            self.hud.size2Icon:setUVs(self.hud.size2Icon.activeUVs);
        else
            self.hud.size2Text:setColor(1, 1, 1, 1);
            self.hud.size2Icon:setUVs(self.hud.size2Icon.normalUVs);
        end
        
        if self.whPresetChanged == 3 then
            self.hud.size3Text:setColor(0.2122, 0.5271, 0.0307, 1);
            self.hud.size3Icon:setUVs(self.hud.size3Icon.activeUVs);
        else
            self.hud.size3Text:setColor(1, 1, 1, 1);
            self.hud.size3Icon:setUVs(self.hud.size3Icon.normalUVs);
        end
        
        -- x albero di fronte alla testa di taglio
        if g_currentMission.controlledVehicle.cutNode ~= nil and self.curSplitShape ~= nil and self.attachedSplitShape == nil then
            local x, y, z = getWorldTranslation(g_currentMission.controlledVehicle.cutNode);
            Utils.renderTextAtWorldPosition(x, y + 0.05, z, self.shapeInfoText, getCorrectTextSize(0.016), 0);
        end
        
        -- x albero già tagliato e "grabbato" dalla testa di taglio
        if g_currentMission.controlledVehicle.hasAttachedSplitShape == true then
            local x, y, z = getWorldTranslation(g_currentMission.controlledVehicle.cutNode);
            local lenAndDia = string.format(" m. %02.1f", self.maxTreeSize) .. string.format("  D mm %03d", (self.lastDiameter * 1000));
            if self.maxTreeSize > 0.1 then
                Utils.renderTextAtWorldPosition(x, y + 0.05, z, lenAndDia, getCorrectTextSize(0.016), 0);
            end
        end
    end

end

function whAutomation:setIsTurnedOn(isTurnedOn, noEventSend)
    
    if self.hasAttachedSplitShape ~= nil and self.hasAttachedSplitShape ~= false then
        self:releaseTree();
    else
        if isTurnedOn ~= self.turnOnVehicle.isTurnedOn then
            SetTurnedOnEvent.sendEvent(self, isTurnedOn, noEventSend);
            self.turnOnVehicle.isTurnedOn = isTurnedOn;
            if self.turnOnVehicle.isTurnedOn then
                self:onTurnedOn(noEventSend);
                if self.whStatus ~= whAutomation.STATE_OFF and self.isEntered then
                    self.hud.bg:setIsVisible(true, true);
                end
            else
                self:onTurnedOff(noEventSend);
                self.hud.bg:setIsVisible(false, true);
            end
        end
    end
end

function whAutomation:releaseTree()
    if self.hasAttachedSplitShape ~= nil and self.hasAttachedSplitShape ~= false then
        removeJoint(self.attachedSplitShapeJointIndex);
        self.attachedSplitShapeJointIndex = nil;
        self.attachedSplitShape = nil;
        self:onDelimbTree(false);
        if g_server ~= nil then
            g_server:broadcastEvent(WoodHarvesterOnDelimbTreeEvent:new(self, false), nil, nil, self);
        end
        self:onCutTree(0);
        if g_server ~= nil then
            g_server:broadcastEvent(WoodHarvesterOnCutTreeEvent:new(self, 0), nil, nil, self);
        end
    end
end

function whAutomation:delayedAutoCut()
    self:cutTree(self.currentCutLength);
end

function whAutomation:onCutTree(radius)
    if radius > 0 then
        self.cutCounter = self.cutCounter + 1;
        if self.whStatus == whAutomation.STATE_FAUTO and self.cutCounter > 1 then
            self.callDelayedCut:call(800);
        end
    end
    if radius == 0 then
        self.cutCounter = 0;
    end
end

function whAutomation:changeModeMouseClick(hud, x, y, button)
    if button == Hud.MOUSEBUTTONS_LEFT then
        self:toggleStatus();
    end
end

function whAutomation:size1MouseClick(hud, x, y, button)
    if button == Hud.MOUSEBUTTONS_WHEEL_UP then
        --self.defaultPreset[1] = self.defaultPreset[1] + 0.1;
        self:changeLength(1, 1);
    end
    if button == Hud.MOUSEBUTTONS_WHEEL_DOWN then
        --self.defaultPreset[1] = self.defaultPreset[1] - 0.1;
        self:changeLength(1, -1);
    end
    if self.whPresetChanged == 1 then
        self.currentCutLength = self.defaultPreset[1];
    end
    hud.childs[2]:setText(string.format("%.1f m", self.defaultPreset[1]));
    if button == Hud.MOUSEBUTTONS_LEFT then
        self:toggleLengthSet(1);
    end
end

function whAutomation:size2MouseClick(hud, x, y, button)
    if button == Hud.MOUSEBUTTONS_WHEEL_UP then
        self:changeLength(2, 1);
    end
    if button == Hud.MOUSEBUTTONS_WHEEL_DOWN then
        self:changeLength(2, -1);
    end
    if self.whPresetChanged == 2 then
        self.currentCutLength = self.defaultPreset[2];
    end
    hud.childs[2]:setText(string.format("%.1f m", self.defaultPreset[2]));
    if button == Hud.MOUSEBUTTONS_LEFT then
        self:toggleLengthSet(2);
    end
end

function whAutomation:size3MouseClick(hud, x, y, button)
    if button == Hud.MOUSEBUTTONS_WHEEL_UP then
        self:changeLength(3, 1);
    end
    if button == Hud.MOUSEBUTTONS_WHEEL_DOWN then
        self:changeLength(3, -1);
    end
    if self.whPresetChanged == 3 then
        self.currentCutLength = self.defaultPreset[3];
    end
    hud.childs[2]:setText(string.format("%.1f m", self.defaultPreset[3]));
    if button == Hud.MOUSEBUTTONS_LEFT then
        self:toggleLengthSet(3);
    end
end

function whAutomation:sizeMouseEnter(hud, x, y)
    hud.childs[2]:setColor(0.1, 0.1, 0.1, 1);
end

function whAutomation:sizeMouseLeave(hud, x, y)
    hud.childs[2]:setColor(1, 1, 1, 1);
    if self.whStatus == whAutomation.STATE_FAUTO then
        self.hud.stateIcon:setUVs(self.hud.stateIcon.fnautoUVs)
    end
    if self.whStatus == whAutomation.STATE_NAUTO then
        self.hud.stateIcon:setUVs(self.hud.stateIcon.fnautoUVs)
    end
    if self.whStatus == whAutomation.STATE_ON then
        self.hud.stateIcon:setUVs(self.hud.stateIcon.manualUVs)
    end
end

function whAutomation:toggleStatus(state)
    
    if state == whAutomation.STATE_LEAVE then 
        self.hud.bg:setIsVisible(false, true);
        return;
    end

    local newState = self.whStatus + 1;
    if newState > 3 then
        newState = 0;
    end
    -- non so se servirà... se state viene passato, imposta quello...
    if state ~= nil then
        newState = state
    end

    if self.whStatus == whAutomation.STATE_OFF and newState ~= whAutomation.STATE_OFF then
        self:toggleLengthSet(1, true);
    end

    self.whStatus = newState;
    
    playSample(self.whaSoundSample, 1, 1, 0);
    
    if self.whStatus == whAutomation.STATE_OFF then
        self.whInit = false;
        self.cutMaxRadius = self.originalMaxradius;
        self.cutLengthMax = self.defaultcutLengthMax;
        self.cutLengthMin = self.defaultcutLengthMin;
        self.cutLengthStep = self.defaultcutLengthStep;
        self.currentCutLength = self.defaultcutLengthMin;
        self.hud.bg:setIsVisible(false, true);
        self.whAutomationFadeEffect:play(string.format("   OFF   "));
        return;
    else
        if self.isEntered then 
            self.whInit = true;
            self.cutLengthStep = 0.1;
            self.hud.bg:setIsVisible(true, true);
        end
    end
    
    if self.whStatus == whAutomation.STATE_FAUTO then
        self.hud.stateIcon:setUVs(self.hud.stateIcon.fnautoUVs)
        self.whAutomationFadeEffect:play(string.format("Full Auto ON"));
    end
    if self.whStatus == whAutomation.STATE_NAUTO then
        self.hud.stateIcon:setUVs(self.hud.stateIcon.fnautoUVs)
        self.whAutomationFadeEffect:play(string.format(" Auto ON "));
    end
    if self.whStatus == whAutomation.STATE_ON then
        self.hud.stateIcon:setUVs(self.hud.stateIcon.manualUVs)
        self.whAutomationFadeEffect:play(string.format(" Manual  "));
    end

end

function whAutomation:toggleLengthSet(lengthSet, noSound)
    local newLength = 0;
    if lengthSet ~= nil then
        newLength = lengthSet;
    else
        newLength = self.whPresetChanged + 1;
    end
    -- previene anche eventuali chiamate con parametro errato
    if newLength > 3 then
        newLength = 1;
    end
    
    self.currentCutLength = self.defaultPreset[newLength];
    self.whPresetChanged = newLength;
    
    if self.attachedSplitShape ~= nil and self.maxTreeSize ~= 0 then
        self.updateHud = true;
    end
    
    if noSound then 
        return;
    end

    self.whAutomationFadeEffect:play(string.format("set: %02.1f", self.currentCutLength));
    playSample(self.whaScanSample, 1, 1, 0);

end

function whAutomation:changeLength(numPreset, direction)
    if math.abs(direction) ~= 1 then 
        return;
    end
    self.defaultPreset[numPreset] = self.defaultPreset[numPreset] + (self.cutLengthStep*direction);
    if self.defaultPreset[numPreset] >= 30 then 
        self.defaultPreset[numPreset] = 30;
    end
    if self.defaultPreset[numPreset] <= self.cutLengthStep then
        self.defaultPreset[numPreset] = self.cutLengthStep;
    end
end


--
-- DelayedCallBack
--
-- @author TyKonKet
-- @date  08/03/17
DelayedCallBack = {};
local DelayedCallBack_mt = Class(DelayedCallBack);

function DelayedCallBack:new(callBack, callBackSelf)
    if DelayedCallBack_mt == nil then
        DelayedCallBack_mt = Class(DelayedCallBack);
    end
    local self = {};
    setmetatable(self, DelayedCallBack_mt);
    self.callBack = callBack;
    self.callBackSelf = callBackSelf;
    self.callBackCalled = true;
    self.delay = 0;
    self.delayCounter = 0;
    return self;
end

function DelayedCallBack:update(dt)
    if not self.callBackCalled then
        self.delayCounter = self.delayCounter + dt;
        if self.delayCounter >= self.delay then
            self:callCallBack();
        end
    end
end

function DelayedCallBack:call(delay)
    self.callBackCalled = false;
    if delay == nil or delay == 0 then
        self:callCallBack();
    else
        self.delay = delay;
        self.delayCounter = 0;
    end
end

function DelayedCallBack:callCallBack()
    if self.callBackSelf ~= nil then
        self.callBack(self.callBackSelf);
    else
        self.callBack();
    end
    self.callBackCalled = true;
end
